// Grid system

@function emify($target, $context: $font-size) {
  @if $target == 0 {
    @return 0;
  }
  @return $target / $context + 0em;
}

// set grid rhythm

$grid: 22px; // set to your desired line-height and base grid unit
$font-size: $grid / 1.375; // set the number to your desired line-height ratio

// automagics

$line-height: emify($grid);
$of-default-font-size: percentage($font-size / 16px);

// Responsive Presets

$break-split: $grid * 25;

// Colors

$color-error: red;
$color-error-text: white;

$color-brand-primary: #e5bf49;
$color-brand-secondary: #ff4f94;
$color-brand-tertiary: #d742ff;
$color-brand-dark: #302442;

$color-background: transparentize(#20272f, 0.1);
$color-background-highlight: #aaa;

$color-gray: #111;
$color-green-primary: #9bd555;
$color-green-secondary: #4cbf2c;

$color-white: #fff;
$color-blue-primary: #4995ff;
$color-blue-secondary: #4b77f3;

$color-text: #ffffff;

$color-whisper: #aaa;

// Borders

$border: 1px solid $color-gray;
$border-trans: 1px solid rgba(white, 0.25);
$border-trans-dark: 1px solid rgba(black, 0.1);

// Typefaces

$font-sans: "Montserrat", sans-serif;
$font-sans-bold: "Montserrat", sans-serif;

// Font sizes

@mixin scale-font($size) {
  font-size: $size;
  line-height: $size * 1.5;
}

$font-size-h1: $font-size * 2.5; // 40px
$font-size-h2: $font-size * 1.75; // 32px
$font-size-h3: $font-size * 1.5; // 28px
$font-size-h4: $font-size * 1.25; // 24px
$font-size-h5: $font-size * 1.25; // 20px
$font-size-h6: $font-size; // 16px
$font-size-small: $font-size * 0.875; // 14px
$font-size-smaller: $font-size * 0.75; // 12px
$size-icon: $font-size * 1.5;
$size-icon-small: $font-size * 1.125;

// Other

$opacity-hover: 0.85;

// Mixins

@mixin text-shadow {
  text-shadow: 0px 1px 6px rgba(0, 0, 0, 0.9);
}

@mixin text-shadow-light {
  text-shadow: 0px 1px 2px rgba(0, 0, 0, 0.25);
}

@mixin box-shadow-weak {
  box-shadow: 0 0 2px rgba(0, 0, 0, 0.06), 0 1px 3px rgba(0, 0, 0, 0.08);
}

@mixin box-shadow-low {
  box-shadow: 0 0px 2px rgba(0, 0, 0, 0.06), 0 1px 3px rgba(0, 0, 0, 0.08);
}

@mixin box-shadow {
  box-shadow: 0 1px 3px rgba(0, 0, 0, 0.08), 0 0px 4px rgba(0, 0, 0, 0.12);
}

@mixin box-shadow-high {
  box-shadow: 0 3px 9px rgba(0, 0, 0, 0.12), 0 2px 6px rgba(0, 0, 0, 0.24);
}

@mixin box-shadow-big {
  box-shadow: 0 15px 35px rgba(50, 50, 90, 0.1), 0 5px 15px rgba(0, 0, 0, 0.07);
}

@mixin box-shadow-little {
  box-shadow: rgba(50, 50, 93, 0.11) 0px 4px 6px 0px,
    rgba(0, 0, 0, 0.08) 0px 1px 3px 0px;
}

@mixin box-shadow-inner {
  -webkit-box-shadow: inset 0px 1px 4px 0px rgba(0, 0, 0, 0.07);
}

@mixin box-shadow-inner-big {
  box-shadow: inset 0 15px 35px rgba(50, 50, 90, 0.1),
    inset 0 5px 15px rgba(0, 0, 0, 0.07);
}

@mixin box-shadow-kill {
  box-shadow: 0 1px 3px rgba(0, 0, 0, 0), 0 1px 2px rgba(0, 0, 0, 0);
}

@mixin box-sizing($box-sizing-value: border-box) {
  -moz-box-sizing: $box-sizing-value;
  -webkit-box-sizing: $box-sizing-value;
  box-sizing: $box-sizing-value;
}

@mixin corners($tr: 4px, $tl: 4px, $bl: 4px, $br: 4px) {
  /* this could probably be less verbose at some point */
  -webkit-border-top-left-radius: $tr;
  -moz-border-radius-topleft: $tr;
  border-top-left-radius: $tr;
  -webkit-border-top-right-radius: $tl;
  -moz-border-radius-topright: $tl;
  border-top-right-radius: $tl;
  -webkit-border-bottom-left-radius: $bl;
  -moz-border-radius-bottomleft: $bl;
  border-bottom-left-radius: $bl;
  -webkit-border-bottom-right-radius: $br;
  -moz-border-radius-bottomright: $br;
  border-bottom-right-radius: $br;
}

@mixin card {
  // @include box-shadow-low;
  @include corners;
  margin: $grid / 2 $grid / 1.5;
}

@mixin flex_column {
  display: flex;
  flex-direction: column;
  align-items: center;
}

@mixin flex_row {
  display: flex;
  flex-direction: row;
  align-items: center;
}

@mixin row {
  @include flex_row;
  padding: $grid/2 $grid/1.5;
  min-height: 54px;
  width: 100%;
}

@mixin gradient($stop1, $stop2) {
  background: -moz-linear-gradient(top, $stop1, $stop2); /* FF3.6+ */
  background: -webkit-gradient(
    linear,
    left top,
    left bottom,
    color-stop(0%, rgba(255, 255, 255, 0.01)),
    color-stop(16%, rgba(255, 255, 255, 1))
  ); /* Chrome,Safari4+ */
  background: -webkit-linear-gradient(
    top,
    $stop1,
    $stop2
  ); /* Chrome10+,Safari5.1+ */
  background: -o-linear-gradient(top, $stop1, $stop2); /* Opera 11.10+ */
  background: -ms-linear-gradient(top, $stop1, $stop2); /* IE10+ */
  background: linear-gradient(to bottom, $stop1, $stop2); /* W3C */
}

@mixin gradient-horizontal($stop1, $stop2) {
  background: -moz-linear-gradient(left, $stop1, $stop2); /* FF3.6+ */
  background: -webkit-gradient(
    linear,
    left center,
    right center,
    color-stop(0%, rgba(255, 255, 255, 0.01)),
    color-stop(16%, rgba(255, 255, 255, 1))
  ); /* Chrome,Safari4+ */
  background: -webkit-linear-gradient(
    left,
    $stop1,
    $stop2
  ); /* Chrome10+,Safari5.1+ */
  background: -o-linear-gradient(left, $stop1, $stop2); /* Opera 11.10+ */
  background: -ms-linear-gradient(left, $stop1, $stop2); /* IE10+ */
  background: linear-gradient(to right, $stop1, $stop2); /* W3C */
}

@mixin gradient-diagonal-topleft($stop1, $stop2) {
  background: -moz-linear-gradient(-45deg, $stop1, $stop2); /* FF3.6+ */
  background: -webkit-linear-gradient(
    -45deg,
    $stop1,
    $stop2
  ); /* Chrome10+,Safari5.1+ */
  background: -o-linear-gradient(-45deg, $stop1, $stop2); /* Opera 11.10+ */
  background: -ms-linear-gradient(-45deg, $stop1, $stop2); /* IE10+ */
  background: linear-gradient(135deg, $stop1, $stop2); /* W3C */
  filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='$stop1', endColorstr='$stop2',GradientType=1 ); /* IE6-9 fallback on horizontal gradient */
}

@mixin gradient-brand {
  @include gradient-horizontal($color-brand-secondary, $color-brand-primary);
}

@mixin gradient-brand-animated {
  background: -moz-linear-gradient(
    -45deg,
    $color-brand-primary,
    $color-brand-primary,
    $color-brand-secondary,
    $color-brand-tertiary,
    $color-blue-secondary,
    $color-green-secondary,
    $color-green-secondary
  ); /* FF3.6+ */
  background: -webkit-linear-gradient(
    -45deg,
    $color-brand-primary,
    $color-brand-primary,
    $color-brand-secondary,
    $color-brand-tertiary,
    $color-blue-secondary,
    $color-green-secondary,
    $color-green-secondary
  ); /* Chrome10+,Safari5.1+ */
  background: -o-linear-gradient(
    -45deg,
    $color-brand-primary,
    $color-brand-primary,
    $color-brand-secondary,
    $color-brand-tertiary,
    $color-blue-secondary,
    $color-green-secondary,
    $color-green-secondary
  ); /* Opera 11.10+ */
  background: -ms-linear-gradient(
    -45deg,
    $color-brand-primary,
    $color-brand-primary,
    $color-brand-secondary,
    $color-brand-tertiary,
    $color-blue-secondary,
    $color-green-secondary,
    $color-green-secondary
  ); /* IE10+ */
  background: linear-gradient(
    135deg,
    $color-brand-primary,
    $color-brand-primary,
    $color-brand-secondary,
    $color-brand-tertiary,
    $color-blue-secondary,
    $color-green-secondary,
    $color-green-secondary
  ); /* W3C */
  background-size: 600% 600%;
  -webkit-animation: Gradient 40s ease infinite;
  -moz-animation: Gradient 40s ease infinite;
  animation: Gradient 40s ease infinite;
}

@-webkit-keyframes Gradient {
  0% {
    background-position: 0% 50%;
  }
  50% {
    background-position: 100% 50%;
  }
  100% {
    background-position: 0% 50%;
  }
}

@-moz-keyframes Gradient {
  0% {
    background-position: 0% 50%;
  }
  50% {
    background-position: 100% 50%;
  }
  100% {
    background-position: 0% 50%;
  }
}

@keyframes Gradient {
  0% {
    background-position: 0% 50%;
  }
  50% {
    background-position: 100% 50%;
  }
  100% {
    background-position: 0% 50%;
  }
}

@mixin gradient-brand-pantone {
  @include gradient-horizontal(#f04e98, #ff9e1a);
}

@mixin gradient-brand-secondary {
  @include gradient-horizontal($color-brand-secondary, $color-brand-tertiary);
}

@mixin gradient-bitcoin {
  @include gradient-horizontal(
    $color-bitcoin-primary,
    $color-bitcoin-secondary
  );
}

@mixin gradient-bitcoin-cash {
  @include gradient-horizontal(
    $color-bitcoin-cash-primary,
    $color-bitcoin-cash-secondary
  );
}

@mixin gradient-ethereum {
  @include gradient-horizontal(
    $color-ethereum-primary,
    $color-ethereum-secondary
  );
}

@mixin gradient-omisego {
  @include gradient-horizontal(
    $color-omisego-primary,
    $color-omisego-secondary
  );
}

@mixin gradient-xjp {
  @include gradient-horizontal($color-xjp-primary, $color-xjp-secondary);
}

@mixin gradient-button {
  @include gradient(#c653ff, #8600c8);
}

@mixin gradient-black-fade {
  @include gradient(rgba(0, 0, 0, 0), rgba(0, 0, 0, 1));
}

@mixin gradient-text-brand {
  // Mixins
  @include gradient-brand;
  // Box properties

  // Background & borders
  background-position: 50% 50%;
  -webkit-background-clip: text;
  -webkit-text-fill-color: transparent;
  // Typography

  // Animation

  // Other
}

@mixin gradient-text-brand-secondary {
  // Mixins
  @include gradient-brand-secondary;
  // Box properties

  // Background & borders
  background-position: 50% 50%;
  -webkit-background-clip: text;
  -webkit-text-fill-color: transparent;
  // Typography

  // Animation

  // Other
}

$time: 300ms;

$transition: $time cubic-bezier(0.33, 0.465, 0.18, 1) all;
$transition-motion: $time ease all;

@mixin no_spring {
  // transition: 1s cubic-bezier(0.175, 0.885, 0.200, 1.225) all;
  // -webkit-transition: 1s cubic-bezier(0.175, 0.885, 0.200, 1.225) all;

  transition: all $time cubic-bezier(0.33, 0.465, 0.18, 1); /* custom */

  transition-timing-function: cubic-bezier(0.33, 0.465, 0.18, 1); /* custom */
}

@mixin rounded-corners($radius: $grid * 0.2) {
  border-radius: $radius;
}

@mixin rounded-left-corners($radius: $grid * 0.2) {
  border-radius: $radius 0 0 $radius;
}

@mixin rounded-right-corners($radius: $grid * 0.2) {
  border-radius: 0 $radius $radius 0;
}

@mixin rounded-bottom-left-corner($radius: $grid * 0.2) {
  border-radius: 0 0 0 $radius;
}

@mixin rounded-bottom-right-corner($radius: $grid * 0.2) {
  border-radius: 0 0 $radius 0;
}

@mixin button-row {
  display: flex;
  flex-direction: row;

  & > .button-container {
    padding: 0;
    margin: 0;
    flex-grow: 1;

    & > .button {
      border-radius: 0;
    }
  }
}

@mixin scroll {
  overflow: scroll;
  -webkit-overflow-scrolling: touch;
}

@mixin button {
  // Mixins
  @include box-sizing;
  @include corners;

  // Box properties
  height: $grid * 1.5;
  position: relative;
  display: inline-flex;
  justify-content: center;
  align-items: center;
  flex-direction: row;
  flex-wrap: none;
  flex: 0 0 content;
  padding: 0 $grid;
  border: $border;

  // Background & borders
  background-color: lighten($color-brand-primary, 20%);
  &:hover {
    background-color: $color-brand-primary;
  }

  // Typography
  color: black;
  font-size: $font-size;
  line-height: $line-height;
  font-family: $font-sans-bold;
  font-weight: normal;
  text-align: center;
  text-decoration: none;
  // Animation
  transition: $transition;
  cursor: pointer;
  // Other
}

// Placeholders
%material-box {
  box-shadow: 0 2px 2px 0 rgba(0, 0, 0, 0.14),
    0 3px 1px -2px rgba(0, 0, 0, 0.12), 0 1px 5px 0 rgba(0, 0, 0, 0.2);
}

%material-button {
  @extend %material-box;
  border: 0;
  border-radius: 2px;
  padding: 10px 15px;
}

@mixin absolute-full {
  position: absolute;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
}

@mixin fixed-full {
  position: fixed;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
}

@mixin row-padding-between($space: $grid) {
  & > .ui-column,
  & > .ui-row,
  & > .ui-cell {
    margin-left: $space;
    margin-right: $space;

    &:first-child {
      margin-left: 0;
    }
    &:last-child {
      margin-right: 0;
    }
  }
}

@mixin column-padding-between($space: $grid) {
  & > .ui-column,
  & > .ui-row,
  & > .ui-cell {
    margin-top: $space;
    margin-bottom: $space;

    &:first-child {
      margin-top: 0;
    }
    &:last-child {
      margin-bottom: 0;
    }
  }
}

@mixin padding-between($space: $grid) {
  &.ui-row {
    @include row-padding-between($space);
  }

  &.ui-column {
    @include column-padding-between($space);
  }
}
